## ros-melodic-ros-babel-fish 0.9.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(ros_babel_fish)

# If the value doesn't fit, an exception is thrown in any case because that could result in unexpected behavior and can not be ignored lightly
option(WARN_ON_INCOMPATIBLE_TYPE "If ON a warning is printed if a value message is set or accessed with a type that does not allow casting without loss of information" ON)

if (WARN_ON_INCOMPATIBLE_TYPE)
  add_definitions(-DRBF_WARN_ON_INCOMPATIBLE_TYPE)
endif ()

## Compile as C++11, supported in ROS Kinetic and newer
add_compile_options(-std=c++11)

add_definitions(-Wall -Wextra)

#set(CMAKE_BUILD_TYPE "Debug")

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS actionlib roscpp roslib std_msgs)
find_package(OpenSSL REQUIRED)

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if your package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
  INCLUDE_DIRS include
  LIBRARIES ros_babel_fish
  CATKIN_DEPENDS roscpp roslib actionlib
  DEPENDS OPENSSL
)

###########
## Build ##
###########

## Specify additional locations of header files
## Your package locations should be listed before other locations
include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${OPENSSL_INCLUDE_DIR}
)

set(LIBRARIES
  ${catkin_LIBRARIES}
  OpenSSL::SSL
  stdc++fs
)

set(SOURCES
  src/generation/providers/integrated_description_provider.cpp
  src/generation/description_provider.cpp
  src/generation/message_creation.cpp
  src/messages/array_message.cpp
  src/messages/compound_message.cpp
  src/messages/value_message.cpp
  src/babel_fish.cpp
  src/babel_fish_message.cpp
  src/message.cpp
  src/message_extractor.cpp
)


## Declare a C++ library
add_library(${PROJECT_NAME} ${SOURCES})
target_link_libraries(${PROJECT_NAME} ${LIBRARIES})

## Declare examples as C++ executables
add_executable(${PROJECT_NAME}_any_publisher examples/any_publisher.cpp)
## Specify libraries to link a library or executable target against
target_link_libraries(${PROJECT_NAME}_any_publisher ${PROJECT_NAME} ${LIBRARIES})
set_target_properties(${PROJECT_NAME}_any_publisher PROPERTIES OUTPUT_NAME any_publisher PREFIX "")

add_executable(${PROJECT_NAME}_any_subscriber examples/any_subscriber.cpp)
target_link_libraries(${PROJECT_NAME}_any_subscriber ${PROJECT_NAME} ${LIBRARIES})
set_target_properties(${PROJECT_NAME}_any_subscriber PROPERTIES OUTPUT_NAME any_subscriber PREFIX "")

add_executable(${PROJECT_NAME}_message_info examples/message_info.cpp)
target_link_libraries(${PROJECT_NAME}_message_info ${PROJECT_NAME} ${LIBRARIES})
set_target_properties(${PROJECT_NAME}_message_info PROPERTIES OUTPUT_NAME message_info PREFIX "")

add_executable(${PROJECT_NAME}_troll_node examples/troll_node.cpp)
target_link_libraries(${PROJECT_NAME}_troll_node ${PROJECT_NAME} ${LIBRARIES})
set_target_properties(${PROJECT_NAME}_troll_node PROPERTIES OUTPUT_NAME troll_node PREFIX "")

add_executable(${PROJECT_NAME}_service_info examples/service_info.cpp)
target_link_libraries(${PROJECT_NAME}_service_info ${PROJECT_NAME} ${LIBRARIES})
set_target_properties(${PROJECT_NAME}_service_info PROPERTIES OUTPUT_NAME service_info PREFIX "")

add_executable(${PROJECT_NAME}_service_server examples/service_server.cpp)
target_link_libraries(${PROJECT_NAME}_service_server ${PROJECT_NAME} ${LIBRARIES})
set_target_properties(${PROJECT_NAME}_service_server PROPERTIES OUTPUT_NAME service_server PREFIX "")

add_executable(${PROJECT_NAME}_service_client examples/service_client.cpp)
target_link_libraries(${PROJECT_NAME}_service_client ${PROJECT_NAME} ${LIBRARIES})
set_target_properties(${PROJECT_NAME}_service_client PROPERTIES OUTPUT_NAME service_client PREFIX "")

add_executable(${PROJECT_NAME}_action_client examples/action_client.cpp)
target_link_libraries(${PROJECT_NAME}_action_client ${PROJECT_NAME} ${LIBRARIES})
set_target_properties(${PROJECT_NAME}_action_client PROPERTIES OUTPUT_NAME action_client PREFIX "")


#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html

## Mark executables for installation
## See http://docs.ros.org/melodic/api/catkin/html/howto/format1/building_executables.html
install(TARGETS
  ${PROJECT_NAME}_action_client
  ${PROJECT_NAME}_any_publisher
  ${PROJECT_NAME}_any_subscriber
  ${PROJECT_NAME}_message_info
  ${PROJECT_NAME}_troll_node
  ${PROJECT_NAME}_service_info
  ${PROJECT_NAME}_service_server
  ${PROJECT_NAME}_service_client
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

## Mark libraries for installation
install(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})

## Mark cpp header files for installation
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
  PATTERN ".svn" EXCLUDE
)


#############
## Testing ##
#############

if (CATKIN_ENABLE_TESTING)
  find_package(rostest REQUIRED)
  find_package(ros_babel_fish_test_msgs REQUIRED)
  include_directories(${ros_babel_fish_test_msgs_INCLUDE_DIRS})

  add_rostest_gtest(${PROJECT_NAME}_test_message test/test_message.test test/message.cpp)
  target_link_libraries(${PROJECT_NAME}_test_message ${PROJECT_NAME})
  set_target_properties(${PROJECT_NAME}_test_message PROPERTIES OUTPUT_NAME test_message PREFIX "")

  add_rostest_gtest(${PROJECT_NAME}_test_message_decoding test/test_message_decoding.test test/message_decoding.cpp)
  target_link_libraries(${PROJECT_NAME}_test_message_decoding ${PROJECT_NAME} ${ros_babel_fish_test_msgs_LIBRARIES})
  set_target_properties(${PROJECT_NAME}_test_message_decoding PROPERTIES OUTPUT_NAME test_message_decoding PREFIX "")

  add_rostest_gtest(${PROJECT_NAME}_test_message_encoding test/test_message_encoding.test test/message_encoding.cpp)
  target_link_libraries(${PROJECT_NAME}_test_message_encoding ${PROJECT_NAME} ${ros_babel_fish_test_msgs_LIBRARIES})
  set_target_properties(${PROJECT_NAME}_test_message_encoding PROPERTIES OUTPUT_NAME test_message_encoding PREFIX "")

  add_rostest_gtest(${PROJECT_NAME}_test_message_extractor test/test_message_extractor.test test/message_extractor.cpp)
  target_link_libraries(${PROJECT_NAME}_test_message_extractor ${PROJECT_NAME} ${ros_babel_fish_test_msgs_LIBRARIES})
  set_target_properties(${PROJECT_NAME}_test_message_extractor PROPERTIES OUTPUT_NAME test_message_extractor PREFIX "")

  add_rostest_gtest(${PROJECT_NAME}_test_message_lookup test/test_message_lookup.test test/message_lookup.cpp)
  target_link_libraries(${PROJECT_NAME}_test_message_lookup ${PROJECT_NAME} ${ros_babel_fish_test_msgs_LIBRARIES})
  set_target_properties(${PROJECT_NAME}_test_message_lookup PROPERTIES OUTPUT_NAME test_message_lookup PREFIX "")

  add_rostest_gtest(${PROJECT_NAME}_test_service_lookup test/test_service_lookup.test test/service_lookup.cpp)
  target_link_libraries(${PROJECT_NAME}_test_service_lookup ${PROJECT_NAME} ${ros_babel_fish_test_msgs_LIBRARIES})
  set_target_properties(${PROJECT_NAME}_test_service_lookup PROPERTIES OUTPUT_NAME test_service_lookup PREFIX "")

  add_rostest_gtest(${PROJECT_NAME}_test_service_client test/test_service_client.test test/service_client.cpp)
  target_link_libraries(${PROJECT_NAME}_test_service_client ${PROJECT_NAME})
  set_target_properties(${PROJECT_NAME}_test_service_client PROPERTIES OUTPUT_NAME test_service_client PREFIX "")

  add_executable(${PROJECT_NAME}_test_service_client_services test/service_client_test_services.cpp)
  target_link_libraries(${PROJECT_NAME}_test_service_client_services ${PROJECT_NAME})
  set_target_properties(${PROJECT_NAME}_test_service_client_services PROPERTIES OUTPUT_NAME test_service_client_services PREFIX "")

  add_rostest_gtest(${PROJECT_NAME}_test_action_client test/test_action_client.test test/action_client.cpp)
  target_link_libraries(${PROJECT_NAME}_test_action_client ${PROJECT_NAME})
  set_target_properties(${PROJECT_NAME}_test_action_client PROPERTIES OUTPUT_NAME test_action_client PREFIX "")

  add_executable(${PROJECT_NAME}_test_action_client_test_server test/action_client_test_server.cpp)
  target_link_libraries(${PROJECT_NAME}_test_action_client_test_server ${PROJECT_NAME})
  set_target_properties(${PROJECT_NAME}_test_action_client_test_server PROPERTIES OUTPUT_NAME test_action_client_test_server PREFIX "")
endif ()

# to run: catkin build ros_babel_fish --no-deps -DENABLE_COVERAGE_TESTING=ON -DCMAKE_BUILD_TYPE=Debug -v --catkin-make-args ros_babel_fish_coverage
# Path to results overview will be printed in the build process
# Big thanks to the moveit people from whose docs I've obtained the information and code to get the coverage
# Note: Sometimes this command has to be run twice. Don't know why. If you do, please tell me!
if(CATKIN_ENABLE_TESTING AND ENABLE_COVERAGE_TESTING)
  find_package(code_coverage REQUIRED)   # catkin package ros-*-code-coverage
  include(CodeCoverage)
  APPEND_COVERAGE_COMPILER_FLAGS()
  set(COVERAGE_EXCLUDES "*/${PROJECT_NAME}/test*" "*/${PROJECT_NAME}/examples*" "*/${PROJECT_NAME}/benchmarks*")
  add_code_coverage(NAME ${PROJECT_NAME}_coverage)
endif ()

=== debian/changelog ===
ros-melodic-ros-babel-fish (0.9.0-1stretch) stretch; urgency=high

  * Added install target for service_info. Cleaned up package.xml
  * Fixed service spec loading wrong response if service spec doesn't contain '---'.
  * Updated integrated description provider for service descriptions to reflect changes in genmsg that caused some tests to fail.
    Both implementations are interoperable and the change should have no impact on service calls using ros_babel_fish but new implementation is now again consistent with message_traits::definition<...>().
    The new implementation is also less complex and faster.
  * Added macros for template calls.
    This replaces the boiler plate code for situations where you would do switch(msg.type()) { ... } and call a template function with the C++ type of the message as a template parameter.
  * Contributors: Stefan Fabian

 -- Stefan Fabian <ros_babel_fish@stefanfabian.me>  Wed, 28 Oct 2020 00:00:00 -0000

ros-melodic-ros-babel-fish (0.8.0-1stretch) stretch; urgency=high

  * Updated install targets and added OpenSSL to dependencies.
  * Added support for lookups from devel spaces.
  * Changed action client specialization default values for queue sizes to prevent information loss.
  * Added missing typedefs.
  * Added specialization for action client to allow creating an ActionClient with a BabelFishAction.
  * Renamed size and data to more descriptive names _sizeInBytes and _stream.
    size and data will be removed in future release.
  * Configuration for Travis and CodeCov. Added test depends. Set CMake min to 3.0 which should work with kinetic but due to the tests requiring melodic, kinetic will remain officially unsupported even though it should work.
  * Removed embedded python description provider. Improved description provider performance.
  * Moved message from stream creation to static fromStream method.
    CompoundMessage now uses template to auto-initialize for easier message construction.
    Changed ArrayMessage interface to use vector-like interface. Old methods deprecated and will be removed in a future version.
  * Renamed targets to include ${PROJECT_NAME} prefix to fix #3 <https://github.com/StefanFabian/ros_babel_fish/issues/3>.
  * Moved benchmarks to separate repo.
  * Added message extractor.
    Updated benchmarks with results for message extractor.
    Fixed examples using old array structure.
  * Added integrated description provider.
    Added deprecated built-ins byte and char.
    Added benchmark.
  * More error checking for embedded python.
  * Updated description for initial release.
  * Commented action stuff which is not yet ready for release.
  * Merge branch 'master' of github.com:StefanFabian/ros_babel_fish
  * Cleanup for initial release.
    Added convenience methods.
    Added a lot of tests.
  * Cleanup for initial release.
    Added convenience methods.
    Added a lot of tests.
  * Added error handling for unknown service. Added special CompoundArrayMessage subclass to provide the element's datatype.
  * Added bool as explicit type.
  * Initial commit
  * Contributors: Stefan Fabian

 -- Stefan Fabian <ros_babel_fish@stefanfabian.me>  Fri, 20 Mar 2020 00:00:00 -0000

=== debian/control ===
Source: ros-melodic-ros-babel-fish
Section: misc
Priority: optional
Maintainer: Stefan Fabian <ros_babel_fish@stefanfabian.me>
Build-Depends: debhelper (>= 9.0.0), openssl, ros-melodic-actionlib, ros-melodic-catkin, ros-melodic-geometry-msgs, ros-melodic-ros-babel-fish-test-msgs, ros-melodic-rosapi, ros-melodic-roscpp, ros-melodic-roscpp-tutorials, ros-melodic-rosgraph-msgs, ros-melodic-roslib, ros-melodic-rostest, ros-melodic-std-msgs, ros-melodic-std-srvs, ros-melodic-visualization-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-ros-babel-fish
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, openssl, ros-melodic-actionlib, ros-melodic-roscpp, ros-melodic-roslib
Description: The ros_babel_fish package

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-ros-babel-fish//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install

## ros-melodic-ros-babel-fish 0.9.3

=== debian/changelog ===
ros-melodic-ros-babel-fish (0.9.3-1bionic) bionic; urgency=high

  * Added some more information to exception messages.
  * Add libssl-dev as a build-export dependency
  * Contributors: AR Dabbour, Stefan Fabian

 -- Stefan Fabian <ros_babel_fish@stefanfabian.me>  Wed, 20 Apr 2022 00:00:00 -0000

ros-melodic-ros-babel-fish (0.9.2-1bionic) bionic; urgency=high

  * Better rosbag support + example (#7 <https://github.com/StefanFabian/ros_babel_fish/issues/7>)
    * Accept a more general IBabelFishMessage interface in read-only functions.
    * Add a rosbag example, add some useful method overloads.
  * Add noetic to CI, improvements to type safety checking (#6 <https://github.com/StefanFabian/ros_babel_fish/issues/6>)
    * Add noetic to CI.
    * Simplify isCompatible() and inBounds() checks, add tests.
    * Moved compatibility checks to header and internal namespace.
    Co-authored-by: Stefan Fabian <mailto:fabian@sim.tu-darmstadt.de>
  * Accept True and False as boolean constants (#4 <https://github.com/StefanFabian/ros_babel_fish/issues/4>)
    Co-authored-by: Stefan Fabian <mailto:fabian@sim.tu-darmstadt.de>
  * Added more explicit warning if message type is not a valid message name.
  * Made BabelFishMessageException subclass of BabelFishException.
  * Contributors: Martin Valgur, Stefan Fabian

 -- Stefan Fabian <ros_babel_fish@stefanfabian.me>  Wed, 22 Dec 2021 00:00:00 -0000

ros-melodic-ros-babel-fish (0.9.1-1bionic) bionic; urgency=high

  * Added missing build depend for openssl headers to fix build for noetic.
  * Contributors: Stefan Fabian

 -- Stefan Fabian <ros_babel_fish@stefanfabian.me>  Thu, 29 Oct 2020 00:00:00 -0000

ros-melodic-ros-babel-fish (0.9.0-1bionic) bionic; urgency=high

  * Added install target for service_info. Cleaned up package.xml
  * Fixed service spec loading wrong response if service spec doesn't contain '---'.
  * Updated integrated description provider for service descriptions to reflect changes in genmsg that caused some tests to fail.
    Both implementations are interoperable and the change should have no impact on service calls using ros_babel_fish but new implementation is now again consistent with message_traits::definition<...>().
    The new implementation is also less complex and faster.
  * Added macros for template calls.
    This replaces the boiler plate code for situations where you would do switch(msg.type()) { ... } and call a template function with the C++ type of the message as a template parameter.
  * Contributors: Stefan Fabian

 -- Stefan Fabian <ros_babel_fish@stefanfabian.me>  Wed, 28 Oct 2020 00:00:00 -0000

ros-melodic-ros-babel-fish (0.8.0-1bionic) bionic; urgency=high

  * Updated install targets and added OpenSSL to dependencies.
  * Added support for lookups from devel spaces.
  * Changed action client specialization default values for queue sizes to prevent information loss.
  * Added missing typedefs.
  * Added specialization for action client to allow creating an ActionClient with a BabelFishAction.
  * Renamed size and data to more descriptive names _sizeInBytes and _stream.
    size and data will be removed in future release.
  * Configuration for Travis and CodeCov. Added test depends. Set CMake min to 3.0 which should work with kinetic but due to the tests requiring melodic, kinetic will remain officially unsupported even though it should work.
  * Removed embedded python description provider. Improved description provider performance.
  * Moved message from stream creation to static fromStream method.
    CompoundMessage now uses template to auto-initialize for easier message construction.
    Changed ArrayMessage interface to use vector-like interface. Old methods deprecated and will be removed in a future version.
  * Renamed targets to include ${PROJECT_NAME} prefix to fix #3 <https://github.com/StefanFabian/ros_babel_fish/issues/3>.
  * Moved benchmarks to separate repo.
  * Added message extractor.
    Updated benchmarks with results for message extractor.
    Fixed examples using old array structure.
  * Added integrated description provider.
    Added deprecated built-ins byte and char.
    Added benchmark.
  * More error checking for embedded python.
  * Updated description for initial release.
  * Commented action stuff which is not yet ready for release.
  * Merge branch 'master' of github.com:StefanFabian/ros_babel_fish
  * Cleanup for initial release.
    Added convenience methods.
    Added a lot of tests.
  * Cleanup for initial release.
    Added convenience methods.
    Added a lot of tests.
  * Added error handling for unknown service. Added special CompoundArrayMessage subclass to provide the element's datatype.
  * Added bool as explicit type.
  * Initial commit
  * Contributors: Stefan Fabian

 -- Stefan Fabian <ros_babel_fish@stefanfabian.me>  Fri, 20 Mar 2020 00:00:00 -0000

=== debian/control ===
Source: ros-melodic-ros-babel-fish
Section: misc
Priority: optional
Maintainer: Stefan Fabian <ros_babel_fish@stefanfabian.me>
Build-Depends: debhelper (>= 9.0.0), libssl-dev, openssl, ros-melodic-actionlib, ros-melodic-catkin, ros-melodic-geometry-msgs <!nocheck>, ros-melodic-ros-babel-fish-test-msgs <!nocheck>, ros-melodic-rosapi <!nocheck>, ros-melodic-roscpp, ros-melodic-roscpp-tutorials <!nocheck>, ros-melodic-rosgraph-msgs <!nocheck>, ros-melodic-roslib, ros-melodic-rostest <!nocheck>, ros-melodic-std-msgs <!nocheck>, ros-melodic-std-srvs <!nocheck>, ros-melodic-visualization-msgs <!nocheck>
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-ros-babel-fish
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libssl-dev, openssl, ros-melodic-actionlib, ros-melodic-roscpp, ros-melodic-roslib
Description: A runtime message handler for ROS.
 Allows subscription, publishing, calling of services and actions with messages known only at runtime.

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"
+		-DCMAKE_PREFIX_PATH="/opt/ros/melodic" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
